#! /usr/bin/perl
# $Id: LiSP2TeX-parser-perl.pl,v 1.2 2000/10/29 18:17:05 queinnec Exp $

# This is an example of an external parser for LiSP2TeX. This is just
# a small example, it is not meant to extract real stuff from Perl files.
# It is indeed used for internal tests of LiSP2TeX and for its documentation.

# This script takes two arguments: the file to parse, the file where
# to put the results.

die "Usage: LiSP2TeX-parser-bk.pl <infile> <outfile>"
    if ( $#ARGV != 1 );
my $infile = $ARGV[0];
my $outfile = $ARGV[1];

open(OUT, "> $outfile")
    || die "Cannot write into $outfile";

# Gather all the lines of a file into a single string:

sub slurp_file {
    my ($infile) = @_;
    open(IN, "< $infile") 
        || die "Cannot open $infile";
    my($s) = '';
    while ( <IN> ) {
        $s .= $_;
    }
    return $s;
}

sub report {
    my ($start, $real_start, $end, $embed, $name) = @_;
    my $dummy = 42;
    print OUT "($start $real_start $end $embed \"$name\")\n";
}

my $file_content = slurp_file($infile);
my $file_length = length($file_content);
my @embed = ();

# Find all 'my' variables within the body of a function:

sub analyse_body {
    my ($pos, $body) = @_;
    #print STDERR "analyse_body($pos, $body)\n";
    while ( $body =~ /(\n)(\s*my\s+([\$@%]\w+)\s*=[^;]*?;)/gos ) {
        my $start = $pos + length($`);
        my $real_start = $start + length($1);
        my $end = $start + length($2) + 1;
        my $name = $3;
        report($start, $real_start, $end, $embed, $name);
    }
}

while ( $file_content =~ 
        /(\n(\s*(\#[^\n]*)?\n)*)sub\s+(\w+)\s*(\{.*?\n\})/gos ) {
    my $start = length($`);
    my $real_start = $start + length($1);
    my $end = $file_length - length($');
    my $name = $4;
    my $body = $5;
    report($start, $real_start, $end, $embed, $name);
    $embed .= " \"$name\"";
    analyse_body($end - length($body), $body);
    $embed = "";
}

# et les my globaux ???

# end of LiSP2TeX-parser-bk.pl
