Release: 1
Version: 2004Apr08
Name: l2t
Summary: Literate programming utility
Serial: 75
Source: http://www-spi.lip6.fr/~queinnec/Programs/l2t-%{version}.tgz
Group: Applications/Publishing
URL: http://www-spi.lip6.fr/~queinnec/WWW/l2t.html
Copyright: GPL
Packager: <Christian.Queinnec@lip6.fr>
Requires: tetex
Provides: l2t

%description 
l2t is a literate programming utility that allows easy
insertions of program source snippets towards TeX files. The
originality of l2t is that it extracts definitions from the files
where they appear and wraps them appropriately within TeX macros for
insertion into documentation files. l2t decorrelates writing
documentation from programming: it is therefore possible to separately
develop programs and documentations and to merge them at the end to
produce up to date final documents. l2t also has some pretty-printing
capabilities (for Scheme definitions only) to produce denotations full
of greek letters. l2t (formerly known as LiSP2TeX) has been used since 1991.

%prep

%setup -n l2t
# $Id: l2t.spec,v 1.7 2003/02/05 10:38:15 queinnec Exp $

%build
echo "This rpm file rebuilds l2t with help of a Scheme compiler on a PC with Linux"
HOSTTYPE=i386_linux
USER=nobody
echo It is possible to choose between Gambit and Bigloo
SCM=bigloo
SCM=gambit
echo ${SCM} is assumed here
BINDIR=/usr/local/bin 
MANDIR=/usr/local/man/man1 
STYDIR=/usr/share/texmf/tex/latex 
DOCDIR=/usr/local/lib/l2t
MAKE_OPTIONS="HOSTTYPE=$HOSTTYPE USER=$USER SCM=$SCM BINDIR=$BINDIR"
MAKE_OPTIONS="MANDIR=$MANDIR STYDIR=$STYDIR DOCDIR=$DOCDIR $MAKE_OPTIONS"
make mkdir $MAKE_OPTIONS
make o/${HOSTTYPE}/${SCM}.LiSP2TeX $MAKE_OPTIONS

%install
HOSTTYPE=i386_linux
USER=nobody
echo It is possible to choose between Gambit and Bigloo
SCM=bigloo
SCM=gambit
echo ${SCM} is assumed here
BINDIR=/usr/local/bin 
MANDIR=/usr/local/man/man1 
STYDIR=/usr/share/texmf/tex/latex 
DOCDIR=/usr/local/lib/l2t
MAKE_OPTIONS="HOSTTYPE=$HOSTTYPE USER=$USER SCM=$SCM BINDIR=$BINDIR"
MAKE_OPTIONS="MANDIR=$MANDIR STYDIR=$STYDIR DOCDIR=$DOCDIR $MAKE_OPTIONS"
make install $MAKE_OPTIONS
texhash

%clean
rm -rf l2t

%files
%dir /usr/local/lib/l2t
/usr/local/bin/l2t
/usr/local/bin/LiSP2TeX
/usr/local/lib/l2t/LiSP2TeX.bk
/usr/local/lib/l2t/LiSP2TeX.dvi
/usr/local/lib/l2t/LiSP2TeX.ps
/usr/local/lib/l2t/default.l2t
/usr/local/lib/l2t/domain.l2t
/usr/local/lib/l2t/number.l2t
/usr/local/lib/l2t/pp.l2t
/usr/local/lib/l2t/qnc.l2t
/usr/local/lib/l2t/sexp.l2t
/usr/local/lib/l2t/slatex.l2t
/usr/local/lib/l2t/tree.l2t
/usr/local/lib/l2t/COPYING
/usr/local/man/man1/l2t.1
/usr/share/texmf/tex/latex/LiSP2TeX.sty
/usr/share/texmf/tex/latex/snippet.sty

%changelog

* Sat Jan  6 2001 <Christian.Queinnec@lip6.fr>

Added external parsers, clean up documentation, renamed lisp2tex into l2t.

* Sun Oct 29 2000 <Christian.Queinnec@lip6.fr>

Added new commands.

* Thu Sep  3 1998 <Christian.Queinnec@lip6.fr>

Replaced Bigloo by Gambit (which is case-sensitive).

* Wed Aug 26 1998 <Christian.Queinnec@lip6.fr>

Merged LiSP2TeXinfo with LiSP2TeX.

* Wed Aug 12 1998 <Christian.Queinnec@lip6.fr>

Added LiSP2TeXinfo to the rpm.

* Thu Mar  5 1998 <Christian.Queinnec@lip6.fr>

This is a generic .spec file. 'make update.spec' adapts it to become
the appropriate .spec file for a distribution. I removed 'bigloo' and
'gcc' in the Requires field since they are only needed to rebuild the
package not to install it.

* Wed Mar  4 1998 <Christian.Queinnec@lip6.fr>

Seems to work now:
  cp `ls -t LiSP2TeX*.tar.gz | head -1` /usr/src/redhat/SOURCES/
  rpm -ba ~queinnec/scm/LiSP/LiSP2TeX.spec
Put the RCS Id string in a shell comment in the prep section. Is there
a comment keyword to insert that string higher in the file ?

* Fri Feb 27 1998 <Christian.Queinnec@lip6.fr>

First attempt to write a rpm file.
