;;; This script is used to compile LiSPTeX for Pseudo (on a Common Lisp).
;;; It requires the defsystem package from Mark Kantrowicz to be present.
;;; Thanks to F. Mato Mira <matomira@lig.di.epfl.ch> who wrote this file.

(setf *lisp2tex-load-package* *package*)

;;; This function is required within port-pseudo.scm. It is defined there
;;; since it has to be expanded by CLtL2.

(defun ps:lisp2tex-eval (exp)
  (cl:handler-case (ps:eval exp (ps:interaction-environment))
        (error (condition)
          (list '***EVALUATION-ERROR*** condition) ) ) )

(setq *defsystem-directory-pathname* (pathname *defsystem-directory*))

(require :make (merge-pathnames "defsystem"
                                *defsystem-directory-pathname*))
(provide :make)

(ps:scheme)
(cl:in-package :user)
 
(eval-when (:execute :load-toplevel :compile-toplevel)  
  (make:compile-system "lisp2tex" :minimal-load cl:t :verbose cl:t)
  (make:load-system    "lisp2tex" :minimal-load t :verbose t)
  )
#|
  #+:excl
  (eval `(in-package ,*lisp2tex-load-package*))
  #-:excl
  (eval `(in-package ',*lisp2tex-load-package*))
  )
  |#

(pushnew :lisp2tex *features*)
(provide :lisp2tex)

;;; end of lisp2tex.lisp
