; {{{ File Description
; Creation : Feb 5, 1996
; We make an another pass to find typedef or struct definitions
; }}}

(define (get-last-comments lis)
  (let loop ((l lis) (res '()))
    (if (pair? l)
	(loop (cdr l) (car l))
	(if (and (pair? res)
		 (pair? (car res)))
	    res
	    '()))))

(define (purge-last-comments lis)
  (let loop ((l lis) (res '()))
    (if (pair? l)
       	(loop (cdr l) (cons (car l) res))
	(cdr res))))

(define (flat-comments lis)
  (let loop ((l lis) (last '()) (res '()))
    (if (pair? l)
	(append (reverse last) res)
	(loop (cdr l)
	      (car l)
	      (if (null? last) res
		  (cons last res))))))

; {{{ The Second Scan
(define (Second_Scan port the_list)
  (secscan port the_list '() 0 0 0 0 0 '()))


(define (secscan port the_list the_res start end stex enex other comments)
  (let loop ((tl the_list) (comments comments) (res the_res))
    (if (pair? tl)
	(let ((tla (car tl))
	      (tld (cdr tl)))
	  (cond
	   ((ender? tla)
	    (secscan-1 port tld res start (c-info-begin tla)
		       stex enex other '()))
	   ((fdef? tla)
	    (secscan-2 port tld res start
		       (c-info-end tla)
		       (c-info-begin tla)
		       (c-info-end tla) other comments))
	   ((comments? tla) (loop tld (cons (cons (- (c-info-begin tla) 1)
						  (c-info-end tla))
					    comments) res))
	   ((macro? tla)
	    (loop tld comments (cons (make-scanned-c-expression
				      (- (c-info-begin tla) 1)
				      (- (c-info-end tla) 1)
				      0
				      0
				      '())
				     res)))
	   (else (loop tld comments res))))
	res)))

(define (secscan-1 port the_list the_res start end stex enex other comments)
  (let loop ((tl the_list) (comments comments) (res the_res))
    (if (pair? tl)
	(let ((tla (car tl))
	      (tld (cdr tl)))
	  (cond
	   ((first? tla) (secscan-3 port tld res (- (c-info-begin tla) 1)
				    end stex enex other (cons comments '())))
	   ((fdef? tla) (secscan-2 port tld res start end
				   (c-info-begin tla)
				   (c-info-end tla) other comments))
	   ((comments? tla) (loop tld (cons (cons (- (c-info-begin tla) 1)
						  (c-info-end tla))
					    comments) res))
	   ((macro? tla)
	    (loop tld comments (cons (make-scanned-c-expression
				      (- (c-info-begin tla) 1)
				      (- (c-info-end tla) 1)
				      0
				      0
				      '())
				     res)))	   
	   (else (loop tld comments res))))
	res)))

(define (secscan-2 port the_list the_res start end stex enex other comments)
  (let loop ((tl the_list) (comments comments) (res the_res))
    (if (pair? tl)
	(let ((tla (car tl))
	      (tld (cdr tl)))
	  (cond
	   ((first? tla)
	    (secscan port tld (cons (make-scanned-c-expression
				     (- (c-info-begin tla) 1)
				     end
				     stex
				     end
				     comments) res)
		     0 0 0 0 0 '()))
	   ((comments? tla) (loop tld (cons (cons (- (c-info-begin tla) 1)
						  (c-info-end tla))
					    comments) res))
	   ((macro? tla)
	    (loop tld comments (cons (make-scanned-c-expression
				      (- (c-info-begin tla) 1)
				      (- (c-info-end tla) 1)
				      0
				      0
				      '())
				     res)))	   
	   (else (loop tld comments res))))
	res)))

(define (secscan-3 port the_list the_res start end stex enex other comments)
  (let loop ((tl the_list) (comments comments) (res the_res))
    (if (pair? tl)
	(let ((tla (car tl))
	      (tld (cdr tl)))
	  (cond
	   ((fdef? tla) (secscan-4 port tld res
				   start end
				   (- (c-info-begin tla) 1)
				   (c-info-end tla) other 
				   comments))
	   ((ender? tla) (secscan-1 port tld
				    (cons (make-scanned-c-expression
					   start
					   end
					   0 0  
					   (get-last-comments comments))
					   res)
				    0 (c-info-end tla) 0 0 0 '()))
	   ((comments? tla) (loop tld (cons (cons (- (c-info-begin tla) 1)
						  (c-info-end tla))
					    comments) res))
	   ((macro? tla)
	    (loop tld comments (cons (make-scanned-c-expression
				      (- (c-info-begin tla) 1)
				      (- (c-info-end tla) 1)
				      0
				      0
				      '())
				     res)))	   
	   (else (loop tld comments res))))
	res)))

(define (secscan-4 port the_list the_res start end stex enex other comments)
  (let loop ((tl the_list) (comments comments) (res the_res))
    (if (pair? tl)
	(let ((tla (car tl))
	      (tld (cdr tl)))
	  (cond
	   ((first? tla) (secscan-5 port tld res start end
				    stex enex
				    (- (c-info-begin tla) 1)
				    comments))
	   ((comments? tla) (loop tld (cons (cons (- (c-info-begin tla) 1)
						  (c-info-end tla))
					    comments) res))
	   ((macro? tla)
	    (loop tld comments (cons (make-scanned-c-expression
				      (- (c-info-begin tla) 1)
				      (- (c-info-end tla) 1)
				      0
				      0
				      '())
				     res)))	   
	   (else loop tld comments res)))
	res)))

(define (secscan-5 port the_list the_res start end stex enex other comments)
  (let ((tla (car the_list)) (tld (cdr the_list)))
    (let ((str (counting-stream-extract port)))
      (cond
       ((isa-substring? "typedef" str other (+ other 7))
	(secscan port tld (cons (make-scanned-c-expression
				 other end other enex
				 (flat-comments comments))
				the_res) 0 0 0 0 0 '()))
       ((isa-substring? "struct" str other (+ 6 other))
	(secscan port tld (cons (make-scanned-c-expression
				 other end stex enex
				 (flat-comments comments))
				the_res) 0 0 0 0 0 '()))
       (else (secscan port the_list
		      (cons (make-scanned-c-expression
			     other enex stex enex
			     (purge-last-comments comments))
			    (cons (make-scanned-c-expression
				   start end 0 0
				   (get-last-comments comments))
				  the_res)) 0 0 0 0 0 '()))))))
; }}}

