;;; $Id: util.scm,v 1.6 1998/08/26 18:40:17 queinnec Exp $
;;; Copyright (c) 1990-98 by Christian Queinnec. All rights reserved.
;;; This file is part of LiSP2TeX, a LiSP and TeX merger.
;;;oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
;;;                                                    LiSP2TeX
;;;   Christian Queinnec
;;;   <Christian.Queinnec@lip6.fr> 
;;;   LIP6 --- Universit Paris 6
;;;   4, place Jussieu
;;;   75252 Paris Cedex 05
;;;   France              
;;;oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo

;;;    This program is free software; you can redistribute it and/or modify
;;;    it under the terms of the GNU General Public License as published by
;;;    the Free Software Foundation; either version 2 of the License, or
;;;    (at your option) any later version.
;;;
;;;    This program is distributed in the hope that it will be useful,
;;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;    GNU General Public License for more details.
;;;
;;;    You should have received a copy of the GNU General Public License
;;;    along with this program; if not, write to the Free Software Foundation,
;;;    Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

;;;oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
;;; These functions do not serve to LiSPTeX. They are there to be
;;; included in the documentation with the FromFile directive.

(define (extend* f x* y*)
  (if (pair? x*)
      (if (pair? y*)
          (extend (extend* f (cdr x*) (cdr y*)) (car x*) (car y*))
          (wrong "Not enough images") )
      (if (null? y*) 
          f
          (wrong "Too much images") ) ) ) 

(define (extend f x y)
  (lambda (u) 
    (if (equal? u x) y (f u)) ) )

;;; This is the expression used to present the indexing modes.

(define (foo x y z) (list x ((lambda (y z) (list y z)) (list x y) z)))

;;; The aim of this function is to provoke an error. You can hook it
;;; on the precise error machinery of your preferred Scheme. The first
;;; programmation just said (car 'not-a-pair-in-wrong) but Bigloo is 
;;; smart enough to emit a warning so I hide a little that I want to
;;; provoke an error.

(define (wrong . args)
  (let ((g (lambda (f)
             (lambda (n) 
               (cons args (f n 0)) ) )))
    ((g /) 42) ) )

;;; end of util.scm
